<?php

// File formatted by MichelK - 28 Feb 2023 for version v7c

/*****************************************************************************
Function files for tng mod, show all family. DuPree, 2019
*****************************************************************************/

	include_once($cms['tngpath'] . $extspath . "/tng_showall_settings.php");
	include_once($cms['tngpath'] . $extspath . "/tng_showall_settings2.php");

/*****************************************************************************
Functions to show patriarchs and matriarchs
*****************************************************************************/

//=======================================
function get_ends($personID, $getperson_url, $tree){
	global $singleanc, $earliest, $text, $people_table, $allow_edit, $imagestr, $showID, $IDbefore_after, $earliest, $nameorder, $tngconfig, $rellink, $session_norels, $L_ind, $P_ind, $LP_ind, $IDbefore_after, $showindLP, $showLP, $eolindsformat, $cms, $ismobile2, $showall_addlines;
	if (!isset($ismobile2)) 
		$ismobile2 = false;
	$persontext = $ttext = $supermom = $superdad = $mother = $father = $e_icon = '';// defining variables
	$startpaternal = 1;
	$startmaternal = 1;
    $family = get_pfamilyID ($personID, $tree);
	$parents = get_pparents_of ( $family, $tree);
	if ($parents != ""){
		$father = $parents["husband"];
		$superdad = $father;
		$mother = $parents["wife"];
		$supermom = $mother;
	}
	while ($startpaternal < 65 AND $father != '' ) {
		$family = get_pfamilyID ($father, $tree);
		$father = get_fatherof ( $family, $tree);
		if ($father != '') 
		   $superdad = $father;
		else $father ='';
   		$startpaternal = $startpaternal+1;
    }

	while ($startmaternal < 65 AND $mother != '')
    {
       $family = get_pfamilyID ($mother, $tree);
   	   $mother = get_motherof ( $family, $tree);
			if ($mother != '') $supermom = $mother;
			else $mother = '';
   		$startmaternal = $startmaternal+1;
    }

	$eoldopt = 'full';
	if ($eoldopt != 'full' AND $eoldopt != 'part' ) 
		$eoldopt = 'full';
	$t =0;

	if ($superdad !='')	{
		$dg = $startpaternal - 1;
		$t =1;
		$sdresult = getPersonData($tree, $superdad);
		$sdassoc =  tng_fetch_assoc( $sdresult );
		$fadate = getBirthInfo( $sdassoc );
		$age = '';
		$age = age($sdassoc);
		if($age != '' ) $fadate = $fadate . " &nbsp;({$text['age']} $age)";
		$righttree = checktree($tree);
		$rightbranch = $righttree ? checkbranch($sdassoc['branch']) : false;
		$ssrights = determineLivingPrivateRights($sdassoc, $righttree, $rightbranch);
		$sdassoc['allow_living'] = $ssrights['living'];
		$sdassoc['allow_private'] = $ssrights['private'];
		if ($ssrights['both']) {
			$fname = getName($sdassoc);
			if ($dg == 1) $relmale = $text['father'];
			if ($dg == 2) $relmale = $text['Grandfather'];
			if ($dg == 3) $relmale = $text['Greatgrandfather'];
			if ($dg > 3 ) $relmale = $dg-2 . " x " . $text['Greatgrandfather'];
			$relmale = '&nbsp;&nbsp;(' . $relmale . ')';
			if ($eolindsformat == 0) $relmale = '&nbsp;&nbsp;('.$dg.' '.$text['generations'].')';
			if ($dg < 75 && $rellink == 1 && $showall_addlines != 'yes')	{
				$relstart = '<a href="relationship.php?altprimarypersonID=&savedpersonID=&secondpersonID=' . $personID . '&maxrels=1&disallowspouses=0&generations=75&tree=' . $tree . '&primarypersonID=' . $superdad. '">';
				if ($dg < 16) 
					$eaicon = '&nbsp;<img src="img/relatelineicon.png" width="10" height="10" title="' . $text["relationship"] . '" style="-webkit-filter: grayscale(75%); /* Safari 6.0 - 9.0 */ filter: grayscale(75%);" >';
				else 
					$eaicon = '';
			
				$relend = '</a>';
				$e_icon = $relstart . $eaicon . $relend;
			}
			if ($rellink == 1 && $showall_addlines == 'yes' )	{
				$relstart = '<a href="tng_associated_lines.php?primaryID='.$personID.'&rootID='.$superdad.'&tree='.$tree.'">';
				$eaicon = '&nbsp;<img src="img/relatelineicon.png" width="10" height="10" title="' . $text["relationship"] . '" style="-webkit-filter: grayscale(75%); /* Safari 6.0 - 9.0 */ filter: grayscale(75%);" >';
				$relend = '</a>';
				$e_icon = $relstart . $eaicon . $relend;
			}							
			if ($relmale != '' && !$session_norels ) 
				$relID = $relmale . $e_icon;
			else 
				$relID = $e_icon;

			if (function_exists('add_bullet_to')) 
				$fname = add_bullet_to ($superdad, $tree, $fname, "small");

			$LP_flag = $showLP ? $sdassoc['living'] && $sdassoc['private'] ? $LP_ind : ($sdassoc['private'] ? $P_ind : ($sdassoc['living'] ? $L_ind : "")) : "";
			if($LP_flag && $sdassoc['deathdate'] && ($LP_flag == $L_ind || $LP_flag == $LP_ind))
				$LP_flag = "( " . $LP_flag . " ? )";

			$skidID = $showID ? " (" . $superdad . ") " : "";
			$b_editstr = ' '; $a_editstr = ' ';
			if (($showID == "") || (!$allow_edit))
				$imagestr = "</a>";$spkidID = "";
			if($allow_edit && $IDbefore_after !=""){
				if ($IDbefore_after == 1) {
					$b_editstr = " <a href=\"admin_editperson.php?personID={$superdad}&amp;tree=$tree&amp;cw=1\" title=\"{$text['edit']}\" target=\"blank\">" . $imagestr . $skidID;$fname=$fname." ".$LP_flag;
				}
				if ($IDbefore_after == 0) 
					$a_editstr = "" . $skidID . " <a href=\"admin_editperson.php?personID={$superdad}&amp;tree=$tree&amp;cw=1\" title=\"{$text['edit']}\" target=\"blank\">" . $imagestr.$LP_flag;
			}
			if ($ismobile2 == false && file_exists($cms['tngpath'] . "js/popup_2.js")){
				$personstr = getPersonPrev($tree, $superdad, $personID);
				$popprev = $ismobile2 ? "" : "ppopup($('#{$superdad}1').html());";
				if ($ttext == '') $ttext = '';
				if ($eoldopt == 'full') 
					$ttext .= $b_editstr . "<a onmouseover=\"$popprev\" href=\"$getperson_url" . "personID=$superdad&amp;tree=$tree\" >" . $fname  . '</a>' . $a_editstr . $fadate . $relID;
				if ($eoldopt == 'part') 
					$ttext .= "<a onmouseover=\"$popprev\" href=\"$getperson_url" . "personID=$superdad&amp;tree=$tree\" >" . $fname  . '</a>' . $a_editstr . $fadate . $relID;
				if ($ismobile2 == false) 
					echo "<div id=\"{$superdad}1\" style=\"display:none;\">$personstr</div>";
			}
			else {
				if ($ttext == '') $ttext = '';
				if ($eoldopt == 'full') 
					$ttext .= $b_editstr . "<a href=\"$getperson_url" . "personID=$superdad&amp;tree=$tree\" >" . $fname  . '</a>' . $a_editstr . $fadate . $relID;
				if ($eoldopt == 'part') 
					$ttext .= "<a href=\"$getperson_url" . "personID=$superdad&amp;tree=$tree\" >" . $fname  . '</a>' . $a_editstr . $fadate . $relID;
			}
		} //determine rights
	} // superdad != ''
	
	if ($supermom != ''){
		if ($t == 1 AND $eoldopt == 'part') $ttext .= '<i> & </i>';
		$dm = $startmaternal - 1;
		if ($dm == 1) $relfemale = $text['mother'];
		if ($dm == 2) $relfemale = $text['Grandmother'];
		if ($dm == 3) $relfemale = $text['Greatgrandmother'];
		if ($dm > 3 ) $relfemale = $dm-2 . " x " . $text['Greatgrandmother'];
		$relfemale = '&nbsp;&nbsp;(' . $relfemale . ')';
		if ($eolindsformat == 0) $relfemale = '&nbsp;&nbsp;('.$dm.' '.$text['generations'].')';
		if ($dm < 75 && $rellink == 1 && $showall_addlines != 'yes')	{
			$relstart = '<a href="relationship.php?altprimarypersonID=&savedpersonID=&secondpersonID=' . $personID . '&maxrels=1&disallowspouses=0&generations=75&tree=' . $tree . '&primarypersonID=' . $supermom . '">';
			$eaicon = '&nbsp;<img src="img/relatelineicon.png" width="10" height="10" title="' . $text["relationship"] . '" style="-webkit-filter: grayscale(75%); /* Safari 6.0 - 9.0 */ filter: grayscale(75%);" >';
			$relend = '</a>';
			$e_icon = $relstart . $eaicon . $relend;
		}
		if ($rellink == 1 && $showall_addlines == 'yes' )	{
			$relstart = '<a href="tng_associated_lines.php?primaryID='.$personID.'&rootID='.$supermom.'&tree='.$tree.'&maternal=1">';
			$eaicon = '&nbsp;<img src="img/relatelineicon.png" width="10" height="10" title="' . $text["relationship"] . '" style="-webkit-filter: grayscale(75%); /* Safari 6.0 - 9.0 */ filter: grayscale(75%);" >';
			$relend = '</a>';
			$e_icon = $relstart . $eaicon . $relend;
			}		
		
		if ($relfemale != '' && !$session_norels ) 
			$relID = $relfemale . $e_icon;
		else 
			$relID = $e_icon;

		$smresult = getPersonData($tree, $supermom);
		$smassoc =  tng_fetch_assoc( $smresult );
		$madate = getBirthInfo( $smassoc );
		$age = '';
		$age = age($smassoc);
		if($age != '' ) $madate = $madate . " &nbsp;({$text['age']} $age)";
		$righttree = checktree($tree);
		$rightbranch = $righttree ? checkbranch($smassoc['branch']) : false;
		$ssrights = determineLivingPrivateRights($smassoc, $righttree, $rightbranch);
		$smassoc['allow_living'] = $ssrights['living'];
		$smassoc['allow_private'] = $ssrights['private'];
		if ($ssrights['both']) {
			$mname = getName($smassoc);
			if (function_exists('add_bullet_to')) 
				$mname = add_bullet_to ($supermom, $tree, $mname, "small");
			$LP_flag = $showLP ? $smassoc['living'] && $smassoc['private'] ? $LP_ind : ($smassoc['private'] ? $P_ind : ($smassoc['living'] ? $L_ind : "")) : "";
			if($LP_flag && $smassoc['deathdate'] && ($LP_flag == $L_ind || $LP_flag == $LP_ind))
				$LP_flag = "( " . $LP_flag . " ? )";

			$skidID = $showID ? " (" . $supermom . ") " : "";
			$b_editstr = ''; $a_editstr = '';
			if (($showID == "") || (!$allow_edit))
				$imagestr = "</a>";$spkidID = "";    //clear ID and icon
			if($allow_edit && $IDbefore_after !=""){
				if ($IDbefore_after == 1){ $b_editstr = " <a href=\"admin_editperson.php?personID={$supermom}&amp;tree=$tree&amp;cw=1\" title=\"{$text['edit']}\" target=\"blank\">" . $imagestr . $skidID;$mname=$mname." ".$LP_flag;}
				if ($IDbefore_after == 0) $a_editstr = " " . $skidID . " <a href=\"admin_editperson.php?personID={$supermom}&amp;tree=$tree&amp;cw=1\" title=\"{$text['edit']}\" target=\"blank\">" . $imagestr.$LP_flag;
			}
			if ($ttext) $ttprefix = '<br>';
			if (!$ismobile2 && file_exists($cms['tngpath'] . "js/popup_2.js")){
				$personstr = getPersonPrev($tree, $supermom, $personID);
				$popprev = $ismobile2 ? "" : "ppopup($('#{$supermom}1').html());";
				if ($eoldopt == 'full') 
					$ttext .= $ttprefix . $b_editstr . "<a onmouseover=\"$popprev\" href=\"$getperson_url" . "personID=$supermom&amp;tree=$tree\" >". $mname . '</a>' . $a_editstr . $madate . $relID;
				if ($eoldopt == 'part') 
					$ttext .= $b_editstr . "</i> <a onmouseover=\"$popprev\" href=\"$getperson_url" . "personID=$supermom&amp;tree=$tree\" >" . $mname  . '</a>' . $a_editstr . $madate . $relID;
				if ($ismobile2 == false) 
					echo "<div id=\"{$supermom}1\" style=\"display:none;\">$personstr</div>";
			}
			else {
				if ($eoldopt == 'full') 
					$ttext .= $ttprefix . $b_editstr . "<a href=\"$getperson_url" . "personID=$supermom&amp;tree=$tree\" >". $mname . '</a>' . $a_editstr . $madate . $relID;
				if ($eoldopt == 'part') 
					$ttext .= "<a href=\"$getperson_url" . "personID=$supermom&amp;tree=$tree\" >" . $mname . '</a>' . $a_editstr . $madate . $relID;
			}
		} //check rights
	} // supermom

	if ($ttext != '' ){
		$ttext = str_replace(' </a>','</a>',$ttext);
		$ttext = str_replace(' ,',',',$ttext);
		if ($singleanc != 1 OR ($singleanc == 1 AND $earliest == 0)){
			$persontext = "<tr>\n";
			$persontext .= "<td valign=\"top\" class=\"fieldnameback\" id=\"lastanc\"><span class=\"fieldname\" style=\"font-size:90%\" >{$text['oldend']}</span><img border=\"0\" src=\"{$cms['tngpath']}img/info_2.png\" width=\"14\" height=\"14\" alt=\"\" onclick=\"tnglitbox = new LITBox('tng_showall_eolinfo.php?type=lines',{overlay:false,width:620,height:200}); return false\"/></td>\n";
			$persontext .= "<td valign=\"top\" class=\"databack\" colspan=\"2\"><div class=\"laarea\">$ttext</div></td>\n";
			$persontext .= "</tr>\n";
		}
		if ($singleanc == 1 AND $earliest == 1)	{
			$newend = str_replace("&", $text['text_and'], $text['oldend']);
			$persontext = "<div id=\"tpm\"  ><i>" . $newend . ":</i>";
			$persontext .= "<br>";
			$persontext .= "<div id=\"pmdiv\" style=\"margin-top:2px;\" >" . $ttext . "</div></div>";
		}
	}

	return $persontext;
} // function get_ends

//=======================================
function get_pfamilyID ($personID, $tree){
	global $children_table;
	//do parents
	$MySQL = "SELECT familyid FROM $children_table WHERE personid = '" . $personID ."' AND gedcom = '" . $tree . "' AND frel != 'foster' AND frel != 'adopted' AND frel != 'stepchild' AND mrel != 'foster' AND mrel != 'adopted' AND mrel != 'stepchild' ";
    $Result = tng_query($MySQL);
	if (mysqli_num_rows($Result) == 1){
		$Row = mysqli_fetch_assoc($Result);
		return $Row["familyid"];
	}else
		return "";
}

//=======================================
function get_pparents_of ($FamilyID, $Tree){
	global $families_table;
	$MySQL = "SELECT husband, wife FROM $families_table WHERE familyID = '" . $FamilyID ."' AND gedcom = '" . $Tree . "'";
	$Result = tng_query($MySQL);
	if (mysqli_num_rows($Result) == 1)	{
		$Row = mysqli_fetch_assoc($Result);
		return $Row;
	}else
		return "";
}

function get_fatherof ($FamilyID, $Tree){
	global $families_table;
	$MySQL = "SELECT husband FROM $families_table WHERE familyID = '" . $FamilyID ."' AND gedcom = '" . $Tree . "'";
	$Result = tng_query($MySQL);
	if (mysqli_num_rows($Result) == 1){
		$Row = mysqli_fetch_assoc($Result);
		return $Row['husband'];
	}else
		return "";
}

function get_motherof ($FamilyID, $Tree){
	global $families_table;
	$MySQL = "SELECT wife FROM $families_table WHERE familyID = '" . $FamilyID ."' AND gedcom = '" . $Tree . "'";
	$Result = tng_query($MySQL);
	if (mysqli_num_rows($Result) == 1){
		$Row = mysqli_fetch_assoc($Result);
		return $Row['wife'];
	}else
		return "";
}

/*****************************************************************************
Functions to add in spouses of children of a family
*****************************************************************************/

function addin_spouses ($tree, $childID, $L_ind, $P_ind, $LP_ind){
	global $getperson_url, $righttree, $text, $minimaldisplay, $chspouses, $spousesymbol, $stext, $mplace, $cms,
	$allow_edit, $imagestr, $L_ind, $P_ind, $LP_ind, $IDbefore_after, $showindLP, $showLP, $showID, $ismobile2;
	//Set variables
    if (isset($ismobile2)) {} else $ismobile2 = false;
    $famchildren = ''; $persontext = ''; $linepref = ''; $linesuffix =''; // set variable if not set
	if ($chspouses == 1){
		$prefix =''; $linepref = '';
		if ($stext == 1) $prefix = $spousesymbol . ' ';
		if ($stext == 2) $prefix = '<i>' . $text['childpartners'] . '</i>';
        if ($childID ) {
			$cmarriages = getSpouseFamilyFullUnion($tree, $childID);
			$cmarrtot = tng_num_rows($cmarriages);
			$cspouselink = '';
		}
		if ($cmarrtot >0) {
			while ( $cmarriagerow =  tng_fetch_assoc( $cmarriages ) ) 	{
				$cmdate = "";
				if ($minimaldisplay == 1 AND $linepref != '') $linepref = '<br>' . $prefix;
				if ($minimaldisplay == 1 AND $linepref == '') $linepref = $prefix;
				if ($cmarriagerow['husband'] == $childID ) $cspouse = $cmarriagerow['wife'] ;
				if ($cmarriagerow['wife'] == $childID ) $cspouse = $cmarriagerow['husband'] ;
				if( $cspouse ) {
					$cspouseresult = getPersonData($tree, $cspouse);
					$cspouserow =  tng_fetch_assoc( $cspouseresult );
					$csbirthinfo = getBirthInfo( $cspouserow );
					$age = '';
					$age = age($cspouserow);
					if($age != '' ) $age = " &nbsp;({$text['age']} $age)";
					$righttree = checktree($tree);
					$rightbranch = $righttree ? checkbranch($cspouserow['branch']) : false;
					$csrights = determineLivingPrivateRights($cspouserow, $righttree, $rightbranch);
					$cspouserow['allow_living'] = $csrights['living'];
					$cspouserow['allow_private'] = $csrights['private'];
					if ($csrights['both']) {
						$skidID = $showID ? " (" . $cspouserow['personID'] . ") " : "";
						$b_editstr = ''; $a_editstr = '';
						if (($showID == "") || (!$allow_edit))
							$imagestr = "</a>";$spkidID = "";    //clear ID and icon
						if($allow_edit && $IDbefore_after !=""){
							if ($IDbefore_after == 1 ) 
								$b_editstr = " <a href=\"admin_editperson.php?personID={$cspouserow['personID']}&amp;tree=$tree&amp;cw=1\" title=\"{$text['edit']}\" target=\"blank\">" . $imagestr . $skidID;
							if ($IDbefore_after == 0) 
								$a_editstr = " " . $skidID . " <a href=\"admin_editperson.php?personID={$cspouserow['personID']}&amp;tree=$tree&amp;cw=1\" title=\"{$text['edit']}\" target=\"blank\">" . $imagestr;
						}
						$LP_flag = $showLP ? $cspouserow['living'] && $cspouserow['private'] ? $LP_ind : ($cspouserow['private'] ? $P_ind : ($cspouserow['living'] ? $L_ind : "")) : "";
						if($LP_flag && $cspouserow['deathdate'] && ($LP_flag == $L_ind || $LP_flag == $LP_ind)) 
							$LP_flag = "( " . $LP_flag . " ? )";
						if($allow_edit) 
							$birthinfo = $LP_flag ? " " . $LP_flag . $csbirthinfo : $csbirthinfo;
						if( $cspouserow['firstname'] || $cspouserow['lastname'] ) {
							$mtag = '<strong>' . $text['marrabbr'] . ' </strong>';
							if ($cmarriagerow['marrdate'] )  
								$dadd = '&nbsp;&nbsp;' . $mtag . ' ' . displayDate($cmarriagerow['marrdate']) . '';
							else 
								$dadd = '';
							if ($minimaldisplay == 1 ) 
								$cmdate = $birthinfo . $age . $dadd;
							if ($minimaldisplay == 0 ) 
								$cmdate = $dadd; $linesuffix = ';'; 
							$cspousename = getName( $cspouserow );
							if (function_exists('add_bullet_to')) 
								$cspousename = add_bullet_to($cspouse, $tree, $cspousename, "small");
							if ($ismobile2 == false && file_exists($cms['tngpath'] . "js/popup_2.js")) {
								$personstr = getPersonPrev($tree, $cspouserow['personID'], $childID);
								$popprev = $ismobile2 ? "" : "ppopup($('#{$cspouserow['personID']}1').html());";
								$cspouselink .= $linepref . $b_editstr . "<a onmouseover=\"$popprev\" href=\"$getperson_url" . "personID={$cspouserow['personID']}&amp;tree=$tree\">$cspousename</a>" . $a_editstr . $cmdate . $linesuffix . "&nbsp;&nbsp;&nbsp;";
								if ($ismobile2 == false) 
									echo "<div id=\"{$cspouserow['personID']}1\" style=\"display:none;\">$personstr</div>";
							}
							else 
								$cspouselink .= $linepref . $b_editstr . "<a href=\"$getperson_url" . "personID={$cspouserow['personID']}&amp;tree=$tree\">$cspousename</a>" . $a_editstr . $cmdate . $linesuffix . "&nbsp;&nbsp;&nbsp;";
						} // Spouse name
						$birthinfo ='';
					} //$csrights
				} //cspouse
			} //while
			$cspouselink = rtrim($cspouselink,';&nbsp;&nbsp;');
			if($csrights['both'] ){
				$prefix ='';
				if ($stext == 1) 
					$prefix = $spousesymbol . ' ';
				if ($stext == 2) 
					$prefix = $text['childpartners'];
				if ($cspouselink AND $minimaldisplay == 0) 
					$persontext .= '<br/><div style="margin-left:14px" > ' . $prefix . $cspouselink . '</div>';
				if ($cspouselink AND $minimaldisplay == 1) 
					$persontext .= '<div style="margin-left:14px" > ' . $cspouselink . '</div>';
			}
		} // $cmarrtot
	} // end of $chspouses == 1

	return array($famchildren, $persontext);
} // function admin_spouse

/*****************************************************************************
Functions to add in other spouses of parents or of spouse
*****************************************************************************/

function addin_ospouses ($tree, $childID, $srights, $personID){
	global $cms, $getperson_url, $righttree, $text, $minimaldisplay, $ospouseindicator, $spousesymbol, $symexclude, $mplace,
	$allow_edit, $imagestr, $L_ind, $P_ind, $LP_ind, $IDbefore_after, $showindLP, $showLP, $showID, $stepparents;
	// define variables
	$supfact = ''; $linepref = ''; $linesuffix = ''; $smarrtot=''; 
    if ($childID) {
        $smarriages = getSpouseFamilyFullUnion($tree, $childID);
		$smarrtot = tng_num_rows($smarriages);
		$sspouselink = '';
	}

	if ($smarrtot >1) {
    	if ($symexclude == 2) $prefix = $spousesymbol;

		while ( $smarriagerow =  tng_fetch_assoc( $smarriages ) ){
			if ($smarriagerow['husband'] == $childID ) $sspouse = $smarriagerow['wife'] ;
			if ($smarriagerow['wife'] == $childID ) $sspouse = $smarriagerow['husband'] ;
			if( $sspouse ) {
				$sspouseresult = getPersonData($tree, $sspouse);
				$sspouserow =  tng_fetch_assoc( $sspouseresult );
				$ssbirthinfo = getBirthInfo( $sspouserow );
				$age = '';
				$age = age($sspouserow);
				if($age != '' ) $age = " &nbsp;({$text['age']} $age)";
				$righttree = checktree($tree);
				$rightbranch = $righttree ? checkbranch($sspouserow['branch']) : false;
				$ssrights = determineLivingPrivateRights($sspouserow, $righttree, $rightbranch);
				$sspouserow['allow_living'] = $ssrights['living'];
				$sspouserow['allow_private'] = $ssrights['private'];
				$smdate = '';
				if ($ssrights['both']) {
					$birthinfo = '';
					$skidID = $showID ? " (" . $sspouserow['personID'] . ") " : "";
					$b_editstr = ''; $a_editstr = '';
					if (($showID == "") || (!$allow_edit))
					{$imagestr = "</a>";$spkidID = "";}    //clear ID and icon
					if($allow_edit && $IDbefore_after !="")	{
						if ($IDbefore_after == 1) 
							$b_editstr = " <a href=\"admin_editperson.php?personID={$sspouserow['personID']}&amp;tree=$tree&amp;cw=1\" title=\"{$text['edit']}\" target=\"blank\">" . $imagestr . $skidID;
						if ($IDbefore_after == 0) 
							$a_editstr = " " . $skidID . " <a href=\"admin_editperson.php?personID={$sspouserow['personID']}&amp;tree=$tree&amp;cw=1\" title=\"{$text['edit']}\" target=\"blank\">" . $imagestr;
					}
					$LP_flag = $showLP ? $sspouserow['living'] && $sspouserow['private'] ? $LP_ind : ($sspouserow['private'] ? $P_ind : ($sspouserow['living'] ? $L_ind : "")) : "";
					if($LP_flag && $sspouserow['deathdate'] && ($LP_flag == $L_ind || $LP_flag == $LP_ind)) 
						$LP_flag = "( " . $LP_flag . " ? )";
					if($allow_edit) 
						$birthinfo = $LP_flag ? " " . $LP_flag . $birthinfo : $birthinfo;
					if( $sspouserow['firstname'] || $sspouserow['lastname'] ) {
						$mtag = '<strong>' . $text['marrabbr'] . ' </strong>';
						if ($smarriagerow['marrdate'] ) 
							$dadd = '&nbsp;&nbsp;' . $mtag . ' ' . displayDate($smarriagerow['marrdate']) . '';
						else 
							$dadd = '';
						if ($minimaldisplay == 1 ) 
							$smdate = $ssbirthinfo . $age . $dadd;
						if ($minimaldisplay == 0 ) 
							$smdate = $dadd;
						$sspousename = getName( $sspouserow );
						if (function_exists('add_bullet_to')) 
							$sspousename = add_bullet_to($sspouse, $tree, $sspousename, "small");
						if ($personID != $sspouserow['personID'] ) {
							if ($minimaldisplay == 0) $linesuffix = ';';
							if ($minimaldisplay == 1) $linepref = '<br>' . $prefix;
							if (file_exists($cms['tngpath'] . "js/popup_2.js"))	{
								$personstr = getPersonPrev($tree, $sspouserow['personID'], $personID);
								$popprev = "ppopup($('#{$sspouserow['personID']}1').html());";
								$sspouselink .= $linepref . $b_editstr . "<a onmouseover=\"$popprev\" href=\"$getperson_url" . "personID={$sspouserow['personID']}&amp;tree=$tree\">$sspousename</a>" . $a_editstr . $birthinfo . $smdate . $linesuffix . "&nbsp;&nbsp;&nbsp;";
								echo "<div id=\"{$sspouserow['personID']}1\" style=\"display:none;\">$personstr</div>";
							}
							else {
								$sspouselink .= $linepref . $b_editstr . "<a href=\"$getperson_url" . "personID={$sspouserow['personID']}&amp;tree=$tree\">$sspousename</a>" . $a_editstr . $birthinfo . $smdate . $linesuffix . "&nbsp;&nbsp;&nbsp;";
							}
						} // marriage date
					} // Spouse name
				} //$ssrights
			} //sspouse
		} //end while
		$sspouselink = rtrim($sspouselink,';&nbsp;&nbsp;');
		if($srights['both'] AND $sspouselink){
			if ($minimaldisplay == 0 ) $supfact .= '<br><span style="margin-left: 15px;"><i>' . $text['otherpartners'] . '</i> ' . $sspouselink . '&nbsp;</span>';
			if ($minimaldisplay == 1) $supfact .= '<span style="margin-left: 15px;"><br><i>' . $text['otherpartners'] . '</i>' . $sspouselink . '&nbsp;</span>';
			if ($stepparents == 2) $supfact = $sspouselink;
		}

	}  // $smarrtot
	return $supfact;
} // end function


?>
