<?php

// File formatted by MichelK - 28 Feb 2023 for version v7c

include("tng_begin.php");
$textpart = "getperson";
include($cms['tngpath'] . "checklogin.php");
include($cms['tngpath'] . "personlib.php" );
/*** Family preview and showall settings ***/
$tree = $_GET['tree'];
$place = $_GET['place'];
$personID = $_GET['pid'];
$sid = $_GET['sid'];
if (!isset($_SESSION[$place.$personID])) {
   session_id($sid);
   session_start();
}
$pids = $_SESSION[$place.$personID];
if ($place == 'Other' && $_SESSION['Other_add'.$personID] != '')  
	$pids = $pids.' '.$_SESSION['Other_add'.$personID];
$color = '#'.$_GET['color'];
$names = '';

/**** Prepare and sort the pid list ****/
$i = 0;
$anc_place = array();
$interim = array_unique(explode(' ',$pids));
foreach ($interim as $c) {
	if ($c[0] == '0') 
		$c = ltrim($c, '0');
	$parents = 0;
	if ($c[0] == 'a') 
		$parents = 1;
	$c = ltrim($c, 'a');
	$gen = strtok($c, '-');
	$pid = substr($c, strpos($c, "-") + 1);
	$anc_place[$i] = array('p'=>$parents, 'g'=>$gen, 'i' =>$pid);
	$i++;
}

usort($anc_place, function($a, $b) {return $a['g'] <=> $b['g'];});

echo '<style> .eol {padding:8px;}
.rectangle{float:left;width:10px;height:10px;margin-right:1px;margin-top:3px;}
.a_indent{margin-left:15px;}
.line1 {background:'.$color.';height:5px;}
.line2 {background:'.$color.';opacity:0.5;height:5px;}
</style>';
echo '<div class="eol">';
echo '<h3>'.$text['EOL_a'].' - '.$place.'</h3>';
echo '<div class="rectangle" style="background:'.$color.';opacity:0.5;"></div>'.$text['singleparent'].'<br>';
echo '<div class="rectangle" style="background:'.$color.';"></div>'.$text['noparents'];

foreach ($anc_place as $ap){
	if ($ap['i'] == '') 
		continue;
	$pid = $ap['i'];
	$gen = $ap['g'];
	$parents = $ap['p'];
	$oldresult = getPersonData($tree, $pid);
	$oldassoc =  tng_fetch_assoc( $oldresult );
	$olddate = getBirthInfo( $oldassoc );
	$righttree = checktree($tree);
	$rightbranch = $righttree ? checkbranch($oldassoc['branch']) : false;
	$ssrights = determineLivingPrivateRights($oldassoc, $righttree, $rightbranch);
	$oldassoc['allow_living'] = $ssrights['living'];
	$oldassoc['allow_private'] = $ssrights['private'];
	if ($ssrights['both']) {
	  if ($parents == 1) {
		$name = '<div class="rectangle" style="background:'.$color.';opacity:0.5;"></div>';
		$name .= '<div class="a_indent"><a title="'.$text["singleparent"].'" style="color:gray !important;" href="getperson.php?personID='.$pid.'&tree='.$tree.'">'.getName($oldassoc).'</a>'.$olddate.'</div>';
	  }
	  if ($parents == 0) {
		$name = '<div class="rectangle" style="background:'.$color.';"></div>';
		$name .= '<div class="a_indent"><a title="'.$text["noparents"].'" href="getperson.php?personID='.$pid.'&tree='.$tree.'">'.getName($oldassoc).'</a>'.$olddate.'</div>';
	  }
	}
	if ($lastgen != $gen) 
		echo '<h5>'.$text['generation'] .' '.$gen.'</h5>';

	echo $name;
	$lastgen = $gen;
}

echo '</div>';

?>
