<?php

// File formatted by MichelK - 28 Feb 2023 for version v7c

include("tng_begin.php");
$textpart = "getperson";
include($cms['tngpath'] . "getlang.php");
tng_db_connect($database_host,$database_name,$database_username,$database_password) or exit;
include($cms['tngpath'] . "checklogin.php");
include($cms['tngpath'] . "personlib.php" );
/*** Family preview and showall settings ***/
$fpfile = $cms['tngpath'] . "familyprevlib101.php";
if (file_exists($fpfile) ) 
	include($fpfile );
include($cms['tngpath'] . $extspath . "/tng_showall_settings.php");
include($cms['tngpath'] . $extspath . "/tng_showall_settings2.php");
include($cms['tngpath'] . $modspath . "/show_all_family_v5i/tng_saf_datasets.php");

/*** Define variables and avoid php warnings ***/
global $sitever,$text;
$_SESSION['destinationpage8'] = $_SESSION['saf_cp'];
$fixit=$superdad=$supermom=$newcheck=$e_icon=$relstart=$eaicon=$relend=$showLP=''; //initializing variables
$personID = $_GET['personID'];
$tree = $_GET['tree'];
$fname = $_GET['fname'];
$IDbefore_after = $_GET['IDbefore_after'];
$showID = $_GET['showID'];
$override = $_GET['override'];
$getperson_url = getURL( "getperson", 1 );
$imagestr = "<img src=\"{$cms['tngpath']}img/tng_edit.gif \" width=\"16\" height=\"15\" style=\"vertical-align: -2px;\" border=\"0\" alt=\"{$text['edit']}\"/></a>";
$L_ind = "<a style=\"color: RED;\">L</a>";
$P_ind = "<a style=\"color: RED;\">P</a>";
$LP_ind = "<a style=\"color: RED;\">L/P</a>";
$divcheck = '<a id="&&&&&"></a>';
if(isset($_SESSION['showlp'])) 
	$showLP = $_SESSION['showlp'];
if ($colordata == '1' || $colordata == '2' || $colordata == '3' )
	$colordata1 = ${'colordata'.$colordata};
if (isset($_SESSION['last_rootcheck']) &&  isset($_SESSION['last_gens']) && isset($_SESSION['fororigins'])) {
	if ($_GET['stem']) == 't' {
		echo 'For origins ';
		print_r($_SESSION['fororigins']);
		echo '<br>Last Rootcheck '.$_SESSION['last_rootcheck'];
		echo '<br>Last gens '.$_SESSION['last_gens'];
		exit;	
	}
	$gens = $_SESSION['last_gens'];
	$oldarray = $_SESSION['last_rootcheck'];

	// function formats numbers for the legend in the donut
	function format_nj_numbers($nj) {
		$cknum = number_format((float)$nj, 2, '.', '');
		if ($cknum < 0.01) 
			$nret = '< 0.01';
		else 
			$nret = $cknum;
		return $nret;
	} //function

	if ($showdonut == 'yes' || $showdonut == 'Yes' || $showdonut == 'YES') {
		$j1=$j2=$j3=$j4=$j5=$j6=$j7=$j8=$j9=$j10=$j11=$j12=$j13=$j14=$j15=$jo='';
		$nj1=$nj2=$nj3=$nj4=$nj5=$nj6=$nj7=$nj8=$nj9=$nj10=$nj11=$nj12=$nj13=$nj14=$nj15=$njo='';
		$percent=0;$fullpercent=0;$opercent=0;$other=$naval=$linesuffix='';
		$jo = $text['saf_other']; $njo = $opercent;
		$orarray = array(array('country'=>'','percent'=>''),array('country'=>'','percent'=>''),
		array('country'=>'','percent'=>''),array('country'=>'','percent'=>''),array('country'=>'','percent'=>''),	array('country'=>'','percent'=>''),array('country'=>'','percent'=>''),
		array('country'=>'','percent'=>''),array('country'=>'','percent'=>''),array('country'=>'','percent'=>''),	array('country'=>'','percent'=>''),array('country'=>'','percent'=>''),array('country'=>'','percent'=>''),array('country'=>'','percent'=>''),array('country'=>'','percent'=>''));
		$x=1; $all = 1;

		foreach ($_SESSION['fororigins'] as $orig) {
			$percent = $orig['percent'];
			$parents = $orig['parents'];
			$person = $orig['person'];
			$query = "SELECT
			IF(bp='', IF(cp='', IF(dp='', IF(burp='', 'Unknown', burp), dp), cp), bp) as place,
			firstname, lastname FROM
			(SELECT firstname, lastname,
			IF(ISNULL(SUBSTRING_INDEX(birthplace, ',', -1)),birthplace,SUBSTRING_INDEX(birthplace, ',', -1)) as bp,
			IF(ISNULL(SUBSTRING_INDEX(altbirthplace, ',', -1)),altbirthplace,SUBSTRING_INDEX(altbirthplace, ',', -1)) as cp,
			IF(ISNULL(SUBSTRING_INDEX(deathplace, ',', -1)),deathplace,SUBSTRING_INDEX(deathplace, ',', -1)) as dp,
			IF(ISNULL(SUBSTRING_INDEX(burialplace, ',', -1)),burialplace,SUBSTRING_INDEX(burialplace, ',', -1)) as burp
			FROM $people_table WHERE personID=$person AND gedcom='$tree') as c";
			$result = tng_query($query);
			$Row = tng_fetch_assoc( $result );
			tng_free_result( $result );
			if( !empty($Row) && $Row['place'] != '' ) {
				$nm =$Row['firstname'].' '.$Row['lastname'];
				$comp = trim($Row['place']); $comck = "'".$comp."'";
				$ulck = $useUSlist;	$ulck = strtolower($ulck);
				if ($ulck == 'united states' || $ulck == 'usa' || $ulck == 'us' || $ulck == 'united states of america' ){ 
					if (strpos($uslist,$comck) !== false) 
						$comp = $useUSlist;
				}
				if ($x == 1) {
					$orarray[0] = array('country'=> $comp,'percent' => $percent);
					$x++;
				}
				else {
					if ($comp == $orarray[0]['country']) {$orarray[0]['percent'] = $percent+$orarray[0]['percent'];}
					elseif ($comp == $orarray[1]['country']) {$orarray[1]['percent'] = $percent+$orarray[1]['percent'];}
					elseif ($comp == $orarray[2]['country']) {$orarray[2]['percent'] = $percent+$orarray[2]['percent'];}
					elseif ($comp == $orarray[3]['country']) {$orarray[3]['percent'] = $percent+$orarray[3]['percent'];}
					elseif ($comp == $orarray[4]['country']) {$orarray[4]['percent'] = $percent+$orarray[4]['percent'];}
					elseif ($comp == $orarray[5]['country']) {$orarray[5]['percent'] = $percent+$orarray[5]['percent'];}
					elseif ($comp == $orarray[6]['country']) {$orarray[6]['percent'] = $percent+$orarray[6]['percent'];}
					elseif ($comp == $orarray[7]['country']) {$orarray[7]['percent'] = $percent+$orarray[7]['percent'];}
					elseif ($comp == $orarray[8]['country']) {$orarray[8]['percent'] = $percent+$orarray[8]['percent'];}
					elseif ($comp == $orarray[9]['country']) {$orarray[9]['percent'] = $percent+$orarray[9]['percent'];}
					elseif ($comp == $orarray[10]['country']) {$orarray[10]['percent'] = $percent+$orarray[10]['percent'];}
					elseif ($comp == $orarray[11]['country']) {$orarray[11]['percent'] = $percent+$orarray[11]['percent'];}
					elseif ($comp == $orarray[12]['country']) {$orarray[12]['percent'] = $percent+$orarray[12]['percent'];}
					elseif ($comp == $orarray[13]['country']) {$orarray[13]['percent'] = $percent+$orarray[13]['percent'];}
					elseif ($comp == $orarray[14]['country']) {$orarray[14]['percent'] = $percent+$orarray[14]['percent'];}
					elseif ($x<16) { $orarray[$x-1] = array('country'=> $comp,'percent' => $percent);$x++;}
					elseif ($comp != '') {$other .= $comp.', '; $opercent = $opercent+$percent;}
					$all++;
				}
			} // check that there is a result
		} //for each

		// Sort all the numbers
		usort($orarray, function($a, $b) {
			if($a['percent']==$b['percent']) return 0;
			return $a['percent'] < $b['percent']?1:-1;
		});
		$x=1;
		foreach ($orarray as $c) {
			if ($c['country'] != '') {
				${"nj" . $x} = $c['percent'];
				${"j" . $x} = $c['country'];
				$x++;
			}
		}
		// Make the data for the chart
		$labels =''; $columns = '';$datacolors = '';
		for ($i=1; $i < $x; $i++) {
		$nj = ${'nj'.$i };
		$nj = floatval($nj);
		$j=${'j'.$i };
		$fullpercent = $fullpercent+$nj;
		$cd = $colordata1[$i-1];
		if ($nj < 0.01 ) {
			$njo = $njo+$nj;
			if ($j != '') $other = $other.', '.$j;
			continue;
			}
		if ($i != 1 && $nj != '') {
			$labels .= ', ';
			$columns .= ', ';
			$datacolors .= ', ';
			}
		if ($nj != '') {
			$labels .=  'data'.$i.': "'.$j.' '.format_nj_numbers($nj).'%"';
			$columns .= '["data'.$i.'", '.$nj.']';
		  $datacolors .= 'data'.$i.': "'.$cd.'"';
		  }
		}
		if ($fullpercent+$njo < 99.99 || $njo != 0) {
		  $njo = 100-$fullpercent;
			$labels .= ', data16: " - '.$jo.' '.format_nj_numbers($njo).'% *"';
		  $columns .= ', ["data16", '.$njo.']';
		  $datacolors .= ', data16: "'.$colordata1[15].'"';
		}
		if ($other != '') {
			$other = array_unique(explode(',', $other));
			sort($other);
			$other = implode(',',$other);
			$other = trim($other);
			$other = trim($other,',');
			$other = substr_replace($other, ' and ', strrpos($other, ','), 1);
		}
		$originphrase = str_replace('NAME', $_GET['fname'], $text['originphrase']);
		// $originphrase = str_replace('(','(', $originphrase);

		ob_start();
		?>
		<style>
		#chart .c3-line-data2 { stroke-width: 5px;}
		#charts {margin-bottom:-40px;overflow:hidden;}
		#otherdiv {display:none;padding:8px; z-index: 250; background-color: white;border: 2px black solid;font-size:80%;position:absolute;right:50px;width:800px;margin-top:-75px;}
		.c3-legend-item {font-size:80% !important;}
		#origin_chart {position: relative; top: -55px;margin-bottom:-50px;overflow: hidden;}
		.c3-chart-arc text {font-size: 10px !important;}
		.c3-chart-arc path {stroke: white; stroke-width: 2px;}
		#togother {font-size: 80%;}
		#tpm {}
		</style>
		<script>
			$("#togother").click(function() {
				$("#otherdiv").toggle();
			});
		</script>
		<link href="css/c3.css" rel="stylesheet">
		<script src="js/d3.min.js"></script>
		<script src="js/c3.min.js"></script>
		<div id="charts" class="EScomboG" >
		  <?php echo $originphrase; ?>
			  <?php // print_r($_SESSION['fororigins']); ?>
			  <?php // echo $_SESSION['bkck']; ?>
				<div id="origin_chart" ></div>
			<?php if ($other != '') { ?> <div id="otherdiv" >* <?php echo $text['saf_other']; ?> (<0.1%): <?php echo $other; ?>. </div>
			<div style="position:relative; margin-top: -38px; z-index: 250;float:right;" ><button id="togother"><?php echo $text['saf_other']; ?></button></div><?php } ?>
		</div>
		<script type="text/javascript">
		var origins_chart = c3.generate({
			bindto: '#origin_chart',
				size: {
				height: 290,
				width: 290
					},
			data: {
					  order: 'desc',
				columns: [ <?php echo $columns; ?> ],
				type : 'donut',
				names: { <?php echo $labels; ?> },
						colors: { <?php echo $datacolors; ?>},
						},
				legend: {position: 'right'},
				tooltip: {
				format: {
					title: function (d) { return 'Data ' + d; },
					value: function (value, ratio, id) {
						var format = id === 'data1' ? d3.format(',') : d3.format('$');
						return format(value);
					}
				}
			},
				donut: {
						title: '<?php echo $text["origins"]; ?>',
						width: 45
						}
		});
		</script>
		<?php
		   $naval = ob_get_clean();

	} // fixit does not equal 1

	if (strpos($oldarray, '2manyfolks') !== false )	{
		$persontext = '
		<script>
		$("#findold").click(function(){
			  $("#earliest").html("<div class=\'loading\'>' . $text["searching"] . '</div>");
		  $.ajax({url: "tng_showall_ajax.php?personID=' . $personID . '&getperson_url=' . $getperson_url . '&tree=' . $tree . '&superdad=' . $superdad . '&supermom=' . $supermom . '&showID=' . $showID . '&IDbefore_after=' . $IDbefore_after . '&override=1&fname='.$fname.'",
			timeout: 60000,
			error: function(jqXHR, textStatus, errorThrown) {
					   $("#earliest").html("Sorry - Ancestor search is taking too long.");
			 },
				success: function(result){
					var s = document.getElementById("pmhere").innerHTML;
				var t = "</td></tr></table>";
				var u = result + s + t;
			  $("#earliest").html(u);
					if (result.includes("ffolk") ) { }
					else {$("#tlastanc").toggle();}
				}

			});
		});
		</script>
		';
			$persontext .= $divcheck . '<table><tr class="tlastanc" ><td id="ffolk" class="laarea"><a id="findold" rel="nofollow" ><button style="font-size: 70%;" > ' . $text["search"] . '</button></a>  ' . $text["clickearly"];
		  $fixit = 1;
	}
	else{
		//  $oldarray = str_replace(' personID = ', '', $oldarray);
		//   $oldarray = str_replace(' OR', ',', $oldarray);
		$oldarray = str_replace('"', '', $oldarray);
		$oldarray = str_replace(',,', ',', $oldarray);
		$i = $i+1;
		// $gens = $i - 2;
		$gens = $gens - 2;
		$gendisplay = $gens - 1;
		if ($eolindsformat == 0) $gendisplay = $i - 2;
		if ($gens == 0) {$relmale = "Self";$relfemale = "Self"; $divcheck = '';}
		if ($gens == 1) {$relmale = $text['Father'];$relfemale = $text['Mother']; $divcheck = '';}
		if ($gens == 2) {$relmale = $text['Grandfather'];$relfemale = $text["Grandmother"];}
		if ($gens == 3) {$relmale = $text['Greatgrandfather'];$relfemale = $text['Greatgrandmother'];}
		if ($gens > 3 ) {$relmale = $gens-2 . " x " . $text['Greatgrandfather'];$relfemale = $gens-2 . " x " . $text['Greatgrandmother'];}
		if ($gens > 0 && $eolindsformat == 0) {$relmale = $gendisplay . ' '.$text['generations']; $relfemale = $relmale; }
		if ($oldarray != ''){
			$oldarray = array_unique(explode(",", $oldarray));
			if (sizeof($oldarray) > 0 )	{
		//		$_SESSION['tastring'] = substr_count($_SESSION['totanc'], ",");
				$sentence = str_replace("EANC#", sizeof($oldarray), $text['expandline']);
				$sentence = str_replace("GEN#", $gendisplay, $sentence);
				$sentence = str_replace("TANC#", $_SESSION['totanc'], $sentence);
				$rsentence = str_replace("EANC#", sizeof($oldarray), $text['expandline2']);
				$rsentence = str_replace("GEN#", $gendisplay, $rsentence);
				$rsentence = str_replace("TANC#", $_SESSION['totanc'], $rsentence);
				if (isset($naval)) $rsentence = '<div style="float:left;width:33%;">'.$naval.'</div><div style="float:right;width:67%;">'.$rsentence.'</div>';
				if ($eolinds == 1) 
					$newend = " " . $text['text_and'] . " " . str_replace('&', $text['text_and'], $text['oldend']); 
				else 
					$newend = '';
				if ($singleanc == 1) $sentence = $text['expandline3'] . $newend . ".";
				if ($override == 1) $ttext = $divcheck . '<div id="sent1" style="display:none;">'.$sentence.'</div><div id="sent2" class="override" ><i>'.$rsentence . '</i></div>';
				else
					$ttext = $divcheck . '<div id="sent1">' . $sentence . '</div><div id="sent2" style="display:none;" ><i>'.$rsentence.'</i></div>';
				if ($override == 1) 
					$ttext .= '<table><tr class="tlastanc" id="togarrow" ><td>';
				else 
					$ttext .= '<table><tr class="tlastanc" id="togarrow" style="display:none" ><td>';
			}

			$i = 1;
			foreach ($oldarray as $oldid){
				if ($oldid){
					if ($i = 1)
						$i = 2; 
					$oldresult = getPersonData($tree, $oldid);
					$oldassoc =  tng_fetch_assoc( $oldresult );
					$olddate = getBirthInfo( $oldassoc );
					$age = '';
					$age = age($oldassoc);
					if(isset($age) && $age != '' ) 
						$olddate = $olddate . " &nbsp;({$text['age']} $age)";
					$righttree = checktree($tree);
					$rightbranch = $righttree ? checkbranch($oldassoc['branch']) : false;
					$ssrights = determineLivingPrivateRights($oldassoc, $righttree, $rightbranch);
					$oldassoc['allow_living'] = $ssrights['living'];
					$oldassoc['allow_private'] = $ssrights['private'];
					if ($ssrights['both']) {
						$oldname = getName($oldassoc);
						if ($gens < 75 && $rellink == 1 && $showall_addlines != 'yes' )	{
							$relstart = '<a href="relationship.php?altprimarypersonID=&savedpersonID=&secondpersonID=' . $personID . '&maxrels=1&disallowspouses=0&generations=75&tree=' . $tree . '&primarypersonID=' . $oldid . '">';
							$eaicon = '&nbsp;<img src="img/relatelineicon.png" width="10" height="10" title="' . $text["relationship"] . '" style="-webkit-filter: grayscale(75%); /* Safari 6.0 - 9.0 */ filter: grayscale(75%);" >';
							$relend = '</a>';
							$e_icon = $relstart . $eaicon . $relend;
						}
						if ($rellink == 1 && $showall_addlines == 'yes' )	{
							$relstart = '<a href="tng_associated_lines.php?primaryID='.$personID.'&rootID='.$oldid.'&tree='.$tree.'">';
					    	$eaicon = '&nbsp;<img src="img/relatelineicon.png" width="10" height="10" title="' . $text["relationship"] . '" style="-webkit-filter: grayscale(75%); /* Safari 6.0 - 9.0 */ filter: grayscale(75%);" >';
							$relend = '</a>';
							$e_icon = $relstart . $eaicon . $relend;
						}											
						$relID = '';
						if ($oldassoc['sex'] == 'M' && $relmale != '' ) 
							$relID = '&nbsp;&nbsp;(' . $relmale . ')';
						if ($oldassoc['sex'] == 'F' && $relfemale != '' ) 
							$relID = '&nbsp;&nbsp;(' . $relfemale . ')';
						if (!$session_norels) 
							$prntrel = $relID; 
						else 
							$prntrel = '';
						if (function_exists('add_bullet_to')) 
							$oldname = add_bullet_to ($oldid, $tree, $oldname, "small");
						$LP_flag = $_SESSION['show_lp'] ? $oldassoc['living'] && $oldassoc['private'] ? $LP_ind : ($oldassoc['private'] ? $P_ind : ($oldassoc['living'] ? $L_ind : "")) : "";
						if($LP_flag && $oldassoc['deathdate'] && ($LP_flag == $L_ind || $LP_flag == $LP_ind)) 
							$LP_flag =  $LP_flag . " ? )";
						$skidID = $showID ? " (" . $oldid . ") " : "";
						$b_editstr = ''; $a_editstr = '';
						if ((!$showID) || (!$allow_edit))
							{$imagestr = "</a>";$skidID = "";}    //clear ID and icon
						if($allow_edit && $IDbefore_after !="")	{
							if ($IDbefore_after == 1)
								$b_editstr = " <a href=\"admin_editperson.php?personID={$oldid}&amp;tree=$tree&amp;cw=1\" title=\"{$text['edit']}\" target=\"blank\">" . $imagestr . $skidID;$oldname=$oldname." ".$LP_flag;
							if ($IDbefore_after == 0) 
								$a_editstr = " " . $skidID . " <a href=\"admin_editperson.php?personID={$oldid}&amp;tree=$tree&amp;cw=1\" title=\"{$text['edit']}\" target=\"blank\">" . $imagestr.$LP_flag;
						}
						if (empty($ismobile2) && file_exists($cms['tngpath'] . "js/popup_2.js")){
							$personstr = getPersonPrev($tree, $oldid, $personID);
							$ismobile2 = '';
							$popprev = $ismobile2 ? "" : "ppopup($('#{$oldid}1').html());";
							$ttext .= $b_editstr . "<a onmouseover=\"$popprev\" href=\"$getperson_url" . "personID=$oldid&amp;tree=$tree\" >" . $oldname  . '</a>' . $a_editstr . $olddate . $prntrel . $e_icon . '<br> ';
							if ($ismobile2 = '') 
								echo "<div id=\"{$oldid}1\" style=\"display:none;\">$personstr</div>";
						}
						else
							$ttext .= $b_editstr . "<a href=\"$getperson_url" . "personID=$oldid&amp;tree=$tree\" >" . $oldname . '</a>' . $a_editstr . $olddate . $prntrel . $e_icon . '<br> ';
			
					} // ssrights
				} // oldid
			} //foreach
			if (sizeof($oldarray) != 0)	{
				$ttext = str_replace(' </a>','</a>',$ttext);
				$ttext = str_replace(' ,',',',$ttext);
				if (isset($persontext)) 
					$persontext .= "<div>$ttext</div>$divcheck";
				else 
					$persontext = "<div>$ttext</div>$divcheck";
			}
		} //oldarray
	} // end else
	echo $persontext;
} // end isset( session... print what ancestors you found

else 
	echo 'Could not find ancestors';

?>
